<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>CRUD User list Page</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!--- DataTable-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">AdminLTE 3</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Admin Pham Dac Thanh</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Danh sách page
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="User_list.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Demo Use list page</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="CRUD_user.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>CRUD user page</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="Filter_order.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Filter order page</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>CRUD User List</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">CRUD User List</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <!-- heading part -->
        <div class="row form-group">
          <div class="col-sm-12 text-center">
            <h1>User catalog</h1>
          </div>
          <div class="col-sm-4">
            <button class="btn btn-success" id="modal-add-new-user">add new user</button>
          </div>
        </div>
        <!-- body part -->
          <table class="table table-striped table-hover table-bordered" id="user-table">
            <thead>
              <th>Id</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </thead>
            <tbody>
            </tbody>
          </table>
      </div>
        <!-- modal part -->
        <!-- modal update user-->
        <div class="modal" tabindex="-1" role="dialog" id="modal-update-user">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Thêm User</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <form action="userDetail">
                  <div class="container">
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="firstName">First Name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" class="form-control" id="inp-update-first-name" placeholder="Fill first name">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="lastName">Last Name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" class="form-control" id="inp-update-last-name" placeholder="Fill last name">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="Subject">Subject</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" class="form-control" id="inp-update-subject" placeholder="Fill subject">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="Country">Country</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="country" id="select-update-country" class="form-control">
                          <option value="VN">Việt Nam</option>
                          <option value="USA">USA</option>
                          <option value="AUS">Australia</option>
                          <option value="VN">Việt Nam</option>
                          <option value="CAN">Canada</option>
                        </select>
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="customerType">Customer Type</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="type" id="select-update-customer-type"class="form-control">
                          <option value="Standard">Standard</option>
                          <option value="Gold">Gold</option>
                          <option value="Premium">Premium</option>
                        </select>
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="registerStatus">Register Status</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="registerStatus" id="select-update-register-status" class="form-control">
                          <option value="Accepted">Accepted</option>
                          <option value="Denied">Denied</option>
                          <option value="Standard">Standard</option>
                          <option value="Gold">Gold</option>
                        </select>
                      </div>
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-primary btn-update-user">Update user</button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              </div>
            </div>
          </div>
        </div>
        <!-- modal add new user-->
        <div class="modal" tabindex="-1" role="dialog" id="modal-add-user">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">User Detail</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <form action="userDetail">
                  <div class="container">
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="firstName">First Name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" class="form-control" id="inp-add-first-name" placeholder="Fill first name">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="lastName">Last Name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" class="form-control" id="inp-add-last-name" placeholder="Fill last name">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="Subject">Subject</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" class="form-control" id="inp-add-subject" placeholder="Fill subject">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="Country">Country</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="country" id="select-add-country"class="form-control">
                          <option value="0">...</option>
                          <option value="VN">Việt Nam</option>
                          <option value="USA">USA</option>
                          <option value="AUS">Australia</option>
                          <option value="VN">Việt Nam</option>
                          <option value="CAN">Canada</option>
                        </select>
                      </div>
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-primary btn-insert-user">Insert user</button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              </div>
            </div>
          </div>
        </div>
        <!-- modal delete user-->
        <div class="modal" tabindex="-1" role="dialog" id="modal-delete-user">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Confirm Delete User</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <p>are you certainly delete this user?</p>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-danger btn-confirm-delete">Confirm</button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              </div>
            </div>
          </div>
        </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->


<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- datatable js-->
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
<script>
  "use strict";
  $(document).ready(function() {
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // array contain all attribute
  var gNameCol = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus" , "action"]
  var gListUser = [];
  //globle variable save user id for handle event update and delete data
  var gUserID = 0; // defualt = 0

  // array varibale define the index of columns correspondingly
  const gUSER_ID_COL = 0;
  const gFIRST_NAME_COL = 1;
  const gLAST_NAME_COL = 2;
  const gCOUNTRY_COL = 3;
  const gSUBJECT_COL = 4;
  const gCUSTOMER_TYPE_COL = 5;
  const gRESGISTER_STATUS_COL = 6;
  const gACTION_COL = 7;
  // base URL
  const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
  const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
  // declare Datatable and maping columns, set structure to datatable
  var gUserTable = $("#user-table").DataTable({
    columns: [
      { data: gNameCol[gUSER_ID_COL] },
      { data: gNameCol[gFIRST_NAME_COL] },
      { data: gNameCol[gLAST_NAME_COL] },
      { data: gNameCol[gCOUNTRY_COL] },
      { data: gNameCol[gSUBJECT_COL] },
      { data: gNameCol[gCUSTOMER_TYPE_COL] },
      { data: gNameCol[gRESGISTER_STATUS_COL] },
      { data: gNameCol[gACTION_COL] }
    ],
    columnDefs: [
      { // định nghĩa lại cột STT
        targets: gACTION_COL,
        defaultContent: `
        <div class="btn-group">
          <button class='btn btn-primary btn-change'>Change</button>,
          <button class='btn btn-danger btn-delete'>Delete</button>
        </div>`
        }
      ]
  });
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  onPageloading()
  $("#modal-add-new-user").click(function(){
    onBtnAddNewUserClick()
  })

  $("#user-table").on("click",".btn-change",function(){
    onBtnChangeUserClick(this)
  })

  $("#user-table").on("click",".btn-delete",function(){
    onBtnDeleteUserClick(this)
  })

  $(".btn-insert-user").click(function(){
    onBtnInsertNewUserClick()
  })

  $(".btn-update-user").click(function(){
    onBtnUpdateUserClick()
  })

  $(".btn-confirm-delete").click(function(){
    onBtnConfirmDeleteUserClick()
  })  

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // funtion handler event page loading
  function onPageloading(){
      // step 1: get data
      // step 2: validate
      // step 3: call api to get data
      $.ajax({
          type: "GET",
          url: "http://203.171.20.210:8080/crud-api/users/",
          dataType: "json",
          success: function (data, status, jqXHR) {
              console.log(data);
              console.log(status);
              console.log(jqXHR);
              // success: function (data, status, jqXHR) {
              alert("get data success");// write success in " "
              // step 4: handle font-end
              gListUser = data
              insertRowToTable(gListUser);
          },
          error: function (jqXHR, status) {
              // error handler
              console.log(jqXHR);
              alert('fail' + jqXHR.status);
          }
      });
    }

  // function handle evnet add new User click
  function onBtnAddNewUserClick() {
  // display modal add user
  $("#modal-add-user").modal("show");
  }
    
  // fucntion handle event change user click
  function onBtnChangeUserClick(paramChangeButton) {
    debugger
    // get Id of user 
    gUserID = getUserIdFromButton(paramChangeButton);
    // show the modal update
    $("#modal-update-user").modal("show");
    // show data to modal update form
    showUserDetailToModalForm(gUserID)
  }

  // fucntion handle event change user click
  function onBtnDeleteUserClick(paramChangeButton) {
    debugger
    // get Id of user 
    gUserID = getUserIdFromButton(paramChangeButton);
    // show the modal update
    $("#modal-delete-user").modal("show");
  }

  // fucntion handle event insert new modal click on modal
  function onBtnInsertNewUserClick(){
    // step 1: get data on modal Form 
    var vNewUser = getNewUser()
    // step 2: validate data
    var vCheck = validateNewUser(vNewUser)
    // step 3: add new user: 
    if(vCheck) {
      // call api post to add insert new user
      $.ajax({
        type: "POST",
        url: gBASE_URL,
        data: JSON.stringify(vNewUser),// now data come in this function
        contentType: gUTF8_TEXT_APPLICATION_HEADER,
        crossDomain: true,
        dataType: "json",
        success: function (data, status, jqXHR) {
          console.log(data);
          console.log(status);
          console.log(jqXHR);
          // B4: xử lý front-end
          alert("Thêm user thành công!");
          // thêm object server return to array glistUser
          gListUser.push(data)
          // reaload DataTable again
          loadDataToUserTable(gListUser)
          // reset modal form
          resertCreateUserForm()
          //hide the modal 
          $("#modal-add-user").modal("hide");
        },
        error: function (jqXHR, status) {
            // error handler
            console.log(jqXHR);
            alert('fail' + jqXHR.status);
        },
      });
    };
  };

  // fucntion handle event update user click on modal update
  function onBtnUpdateUserClick() {
    // step 1: get data on modal Form 
    debugger
    var vUpdateUser = {
      firstname: $("#inp-update-first-name").val(),
      lastname: $("#inp-update-last-name").val(),
      subject: $("#inp-update-subject").val(),
      country: $("#select-update-country option:selected").val(),
      customerType: $("#select-update-customer-type option:selected").val(),
      registerStatus: $("#select-update-register-status option:selected").val(),
    }
    // step 2: validate data
    var vCheck = validateNewUser(vUpdateUser)
    // step 3: update user: 
      // call api post to add insert new user
      if(vCheck){
        $.ajax({
          type: "PUT",
          url: gBASE_URL + gUserID,
          data: JSON.stringify(vUpdateUser),// now data come in this function
          contentType: gUTF8_TEXT_APPLICATION_HEADER,
          crossDomain: true,
          dataType: "json",
          success: function (data, status, jqXHR) {
            console.log(data);
            console.log(status);
            console.log(jqXHR);
            // B4: xử lý front-end
            alert("Update thành công!");
            // update user id
            updateUser(data)
            // reaload DataTable again
            loadDataToUserTable(gListUser)
            //hide the modal 
            $("#modal-update-user").modal("hide");
          },
          error: function (jqXHR, status) {
              // error handler
              console.log(jqXHR);
              alert('fail' + jqXHR.status);
          },
        });
    }
  };
  
  // function handle event on Btn confirm click 
  function onBtnConfirmDeleteUserClick() {
    //step 1: get Data
    //step 2: validate data
    //step 3: call api to delete data
    $.ajax({
        url: gBASE_URL + gUserID ,
        type: 'DELETE',
        dataType: 'json', // added data type
        success: function(result){
          // delete user table on databale client side
          deleteUser(gUserID)
          alert("delete success ")
          //reload dataTable
          loadDataToUserTable(gListUser)
          //hide mode
          $("#modal-delete-user").modal("hide");
        },

        error: function(jqXHR,status, error){
        // error handler
          console.log(jqXHR);
          alert('fail' + status.code);
        },
      });
    
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // function insert data to dataTable 
  function insertRowToTable(paramUser){
      gUserTable.rows.add(paramUser)
      gUserTable.draw() 
    }
  
  // hàm dựa vào button detail (edit or delete) xác định đc id voucher
  function getUserIdFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vUserRowData = gUserTable.row(vTableRow).data();
    console.log(vUserRowData.id);
    $(paramButton).data("id",vUserRowData.id)
    return vUserRowData.id;
  }

  // fucntion get new user from modal form
  function getNewUser(){
    // declare a object to contain user inform
    var vNewUser = {
        firstname:"",
        lastname: "",
        subject: "",
        country: "",
    }
    //pass data on form to object
    vNewUser.firstname = $("#inp-add-first-name").val().trim();
    vNewUser.lastname = $("#inp-add-last-name").val().trim();
    vNewUser.subject = $("#inp-add-subject").val().trim();
    vNewUser.country = $("#select-add-country option:selected").val();
    return vNewUser;
  }

  // function validate new User 
  function validateNewUser(paramNewUser){
    if(paramNewUser.firstname.length == 0) {
      alert("first name still not fill ?")
      return false
    }
    if(paramNewUser.lastname.length == 0) {
      alert("last name still not fill ?")
      return false
    }
    if(paramNewUser.subject.length == 0) {
      alert("subject  still not fill ?")
      return false
    }
    if(paramNewUser.country == 0) {
      alert("country still not select ?")
      return false
    }
    return true;
  }

  // fucntion reset createUser form
  function resertCreateUserForm(){
    $("#inp-add-first-name").val("");
    $("#inp-add-last-name").val("");
    $("#inp-add-subject").val("");
    $("#select-add-country option").first().prop('selected', true)

  }

  // function reload dataTable
  function loadDataToUserTable(paramUser) {
    gUserTable.clear();
    gUserTable.rows.add(paramUser);
    gUserTable.draw();
  }
  
  //function show user inform to modal update
  function showUserDetailToModalForm(paramUserId) {
    var vUserIndex = getIndexFormUserId(paramUserId);
    $("#inp-update-first-name").val(gListUser[vUserIndex].firstname);
    $("#inp-update-last-name").val(gListUser[vUserIndex].lastname);
    $("#inp-update-subject").val(gListUser[vUserIndex].subject);
  }

  /* get voucher index from voucher id
  // input: paramUserId là paramUserId cần tìm index
  / output: trả về chỉ số (index) trong mảng voucher */
  function getIndexFormUserId(paramUserId) {
    var vUserIndex = -1;
    var vUserFound = false;
    var vLoopIndex = 0;
    while(!vUserFound && vLoopIndex < gListUser.length) {
      if(gListUser[vLoopIndex].id === paramUserId) {
        vUserIndex = vLoopIndex;
        vUserFound = true;
      }
      else {
        vLoopIndex ++;
      }
    }
    return vUserIndex;
  }

  // fucntion update user
  function updateUser(data) {
    var vUserIndex = getIndexFormUserId(gUserID);
    gListUser.splice(vUserIndex, 1, data);
  }

  // function delelte user
  function deleteUser(paramUserId) {
    var vUserIndex = getIndexFormUserId(paramUserId);
    gListUser.splice(vUserIndex, 1);
  }

});


  </script>
</body>
</html>
